#include <stdint.h>

#include "fontdefs.h"

const FontHeader *font_GetInfo( int fontid )
{
	return fontlist[fontid];
}

int font_GetLen( const char *text, int fontid )
{
	int len = 0;
	const FontHeader *fh = font_GetInfo( fontid );
	FontGlyph *glyphs = fh->glyphs;

	for( int i = 0; text[i]; i++ ) {
		uint8_t sym = text[i];
		FontGlyph *gl = &glyphs[sym];

		if( i != 0 ) len += gl->left;

		// end, only bitmap width
		if( text[i+1] == 0 ) {

			len += gl->rows ? gl->width : gl->xwidth;

		} else {

			len += gl->xwidth - gl->left;

		}
	}

	return len;
}
