// OpenGL support functions.
// Written by Nils Liaaen Corneliusen.
// License: CC0 1.0 Universal (CC0 1.0) Public Domain Dedication license
// https://www.ignorantus.com

#ifndef GLSTUFFH
#define GLSTUFFH

#include <stdbool.h>
#include <stdint.h>
#include <GL/glew.h>
#include <GL/gl.h>

// in stuff_win32.c
void postRender();
bool initOpenGL( bool display, int width, int height );
double PerfCounter( void );

void initBuffer( GLuint *buffer, GLenum target, int size, void *data );
void copyToBuffer(   GLenum target, GLuint buffer, void *src, int size, GLint bufMask );
void copyFromBuffer( GLenum target, GLuint buffer, void *dst, int size, GLint bufMask );

GLuint loadGraphicsProgram( const char *vertSrc, const char *vertName, const char *fragSrc, const char *fragName );
GLuint loadComputeProgram( const char *compSrc, const char *compName );

#endif
