// Based on "More Colorful Than Average" by ollj
// https://www.shadertoy.com/view/ltBcRc
// License: Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License.

// The original source has been modified so it runs in 60 fps on the NVidia Jetson TX2.
// More information about changes here: https://www.ignorantus.com/pages/xmasdemo2017/

#version 310 es
precision highp float;
layout(location = 0) in vec2 v_texCoord;
layout(location = 0) out vec4 outColor;

layout(std140,binding = 0) uniform stuff
{
    float width, height;
    float frame;
    float colscale;
};

//#define iTime frame
#define iTime tframe

const vec2 shift = vec2( 0.033, 0.14);
const vec2 shift2 = vec2( -0.023, -0.22);

#define l 100 // 120

void main( void )
{
    // timing point for music
    float frameoff = frame-(60.0f*60.0f/60.0f);

    uint no = uint( frameoff * 60.0f );
    no = no % 3100u;
    float tframe = float( no ) / 60.0f;


    vec2 iResolution = vec2( width, height );
    vec2 FragCoord = (1.0f - v_texCoord) * iResolution;

    vec2 v = (FragCoord.xy - iResolution.xy/2.) / min(iResolution.y,iResolution.x) * 30.;
    vec2 vv = v;
//    float ft = iTime+360.1;
    float ft = iTime*0.8f+364.1;
    float tm = ft*0.1;
    float tm2 = ft*0.3;
    vec2 mspt = (vec2(  sin(tm)+cos(tm*0.2)+sin(tm*0.5)+cos(tm*-0.4)+sin(tm*1.3),
                        cos(tm)+sin(tm*0.1)+cos(tm*0.8)+sin(tm*-1.1)+cos(tm*1.5)
                     )+1.0)*0.35; //5x harmonics, scale back to [0,1]
    float R = 0.0;
    float RR = 0.0;
    float RRR = 0.0;
    float a = (1.-mspt.x)*0.5;
    float C = cos(tm2*0.03+a*0.01)*1.1;
    float S = sin(tm2*0.033+a*0.23)*1.1;
    float C2 = cos(tm2*0.024+a*0.23)*3.1;
    float S2 = sin(tm2*0.03+a*0.01)*3.3;
    vec2 xa=vec2(C, -S);
    vec2 ya=vec2(S, C);
    vec2 xa2=vec2(C2, -S2);
    vec2 ya2=vec2(S2, C2);
    float Z = 0.4 + mspt.y*0.3;
    float m = 0.99+sin(iTime*0.03)*0.003;

    int i;
    for ( i = 0; i < l; i += 2 ){

        float r0  = dot(v, v);
        float rr0 = dot(vv,vv);

        if ( r0 > 1.0 )
        {
            r0 = 1.0f / r0;
            v *= r0;
        }
        if ( rr0 > 1.0 )
        {
            rr0 = 1.0f / rr0;
            vv *= rr0;
        }

        v  = vec2( dot(v,  xa),  dot(v,  ya))  * Z + shift;
        vv = vec2( dot(vv, xa2), dot(vv, ya2)) * Z + shift2;

        float r1  = dot(v, v);
        float rr1 = dot(vv,vv);

        if ( r1 > 1.0 )
        {
            r1 = 1.0f / r1;
            v *= r1;
        }
        if ( rr1 > 1.0 )
        {
            rr1 = 1.0f / rr1;
            vv *= rr1;
        }

        v  = vec2( dot(v,  xa),  dot(v,  ya))  * Z + shift;
        vv = vec2( dot(vv, xa2), dot(vv, ya2)) * Z + shift2;

        R   = ( ( R   * m + r0 ) * m ) + rr0;
        RR  = ( ( RR  * m + r0 ) * m ) + rr0;
        RRR = ( ( RRR * m + r0 ) * m ) + rr0;

        R   = ( ( R   * m + r1 ) * m ) + rr1;
        RR  = ( ( RR  * m + r1 ) * m ) + rr1;
        RRR = ( ( RRR * m + r1 ) * m ) + rr1;

    }

    // l-2
    float r  = dot(v, v);
    float rr = dot(vv,vv);

    if ( r > 1.0 )
    {
            r  = 1.0f / r;
            v *= r;
    }
    if ( rr > 1.0 )
    {
        rr  = 1.0f / rr;
        vv *= rr;
    }

    v  = vec2( dot(v,  xa),  dot(v,  ya))  * Z + shift;
    vv = vec2( dot(vv, xa2), dot(vv, ya2)) * Z + shift2;

    R   = ( ( R   * m + r ) * m ) + rr;
    RR  = ( ( RR  * m + r ) * m ) + rr;


    // l-1
    r  = dot(v, v);
    rr = dot(vv,vv);

    if ( r > 1.0 )
    {
            r  = 1.0f / r;
    }
    if ( rr > 1.0 )
    {
        rr  = 1.0f / rr;
    }

    R   = ( ( R   * m + r ) * m ) + rr;

/*
    for ( ; i < l; i++ ){
        float r = dot(v,v);
        float r2 = dot(vv,vv);
        if ( r > 1.0 )
        {
            r = (1.0)/r ;
            v.x = v.x * r;
            v.y = v.y * r;
        }
        if ( r2 > 1.0 )
        {
            r2 = (1.0)/r2 ;
            vv.x = vv.x * r2;
            vv.y = vv.y * r2;
        }
        R *= m;
        R += r;
        R *= m;
        R += r2;
        if(i < l-1){
            RR *= m;
            RR += r;
            RR *= m;
            RR += r2;
            if(i < l-2){
                RRR *= m;
                RRR += r;
                RRR *= m;
                RRR += r2;
            }
        }

        v = vec2( dot(v, xa), dot(v, ya)) * Z + shift;
        vv = vec2( dot(vv, xa2), dot(vv, ya2)) * Z + shift2;
    }
*/

//  float c = ((mod(R,2.0)>1.0)?1.0-fract(R):fract(R));
//  float cc = ((mod(RR,2.0)>1.0)?1.0-fract(RR):fract(RR));
//  float ccc = ((mod(RRR,2.0)>1.0)?1.0-fract(RRR):fract(RRR));

    float rf0 = fract( R );
    float rf1 = fract( RR );
    float rf2 = fract( RRR );
    float c   = ((mod(R,  2.0)>1.0) ? 1.0-rf0 : rf0);
    float cc  = ((mod(RR, 2.0)>1.0) ? 1.0-rf1 : rf1);
    float ccc = ((mod(RRR,2.0)>1.0) ? 1.0-rf2 : rf2);


//    float c   = ((int(R)  &1) == 1) ? 1.0-fract(R)  : fract(R);
//    float cc  = ((int(RR) &1) == 1) ? 1.0-fract(RR) : fract(RR);
//    float ccc = ((int(RRR)&1) == 1) ? 1.0-fract(RRR): fract(RRR);

    outColor = vec4( vec3( ccc, cc, c ), colscale );
}
