// GLSL bilinear scaler that doesn't flicker. Really.
// Written by Nils Liaaen Corneliusen.
// License: CC0 1.0 Universal (CC0 1.0) Public Domain Dedication license
// https://www.ignorantus.com/

#version 310 es
precision highp float;
layout(location = 0) in vec2 v_texCoord;
layout(location = 0) out vec4 outColor;
uniform sampler2D sampid;
uniform float tex_scrw, tex_scrh;
void main()
{
    vec2 vt = v_texCoord;
    vec2 texcoord = vec2( vt.x * tex_scrw, vt.y * tex_scrh );
    vec2 phase = fract( texcoord );
    phase.x = 1.0f - phase.x;

    vec4 p00 = textureOffset( sampid, vt, ivec2(  0, 0 ) );
    vec4 p10 = textureOffset( sampid, vt, ivec2( -1, 0 ) );
    vec4 p01 = textureOffset( sampid, vt, ivec2(  0, 1 ) );
    vec4 p11 = textureOffset( sampid, vt, ivec2( -1, 1 ) );

    vec4 p0010 = mix( p00,   p10,   phase.x );
    vec4 p0111 = mix( p01,   p11,   phase.x );
    vec4 p     = mix( p0010, p0111, phase.y );

    outColor = p;
}
